% % Denne funksjonen leser inn bilder i hdr-format og gir ut et 
% % bilde-array med pixelverdiene, hvor inngangsparametrene bestemmer
% % strrelsen p arrayet. Utgangsverdien blir ogs lagret i filen
% % pixels.txt
% 
% % Parameter    Beskrivelse               Initial verdi  Operating range
% % input_file   Navnet p hdr-bildefilen  ingen          ingen
% % height       Hyden p utgangsbildet   0              hyden p inngangsbildet
% % width        Bredden p utgangsbildet  0              bredden p inngangsbildet
% % start_height startkoordinat for hyden 0              hyden p inngangsbildet
% % start_width  startkoordinat for bredde 0              bredden p inngangsbildet

function output = cut_picture(input_file, height, width, start_height, start_width)

% Leser inn pikselverdiene fra bildet
% read_rle_rgbe() er laget av Lawrence A. Taplin og er tilgjengelig p
% webadressen http://www.cis.rit.edu/mcsl/icam/hdr/read_rle_rgbe.m
I = read_rle_rgbe(input_file);
% Skalerer inngangssignalet
I = I/max(max(max(I)));
Maks_inngang = 2^18;
I = round(I*Maks_inngang);

fwriteid = fopen('pixels.txt','wt');

% Sjekker om inngangsparametrene er gyldige iforhold til strrelsen p
% inngangsbildet
[height_in width_in dim] = size(I);
if(((height+start_height)>height_in) | ((width+start_width)>width_in))
    return;
end;
% Finner det aktuelle omrdet p inngangsbildet og indekserer om
% pikselposisjonene. Det nye bildet blir s sendt ut som utgang av
% funksjonen og lagret til tekstfil for  leses inn i testbenken i VHDL.
for(i=start_height+1:1:height+start_height)
    for(j=start_width+1:1:start_width+width)
        for(d=1:1:dim)
            output(i-start_height, j-start_width, d) = I(i,j,d);
            fprintf(fwriteid, '%6.0f', I(i,j,d));
            fwrite(fwriteid, ' ','char');  
        end
    end
    fprintf(fwriteid, '\n', ' ');
end
fclose(fwriteid)
