% % Denne funksjonen leser inn resultatene fra testbenken til
% % logaritmeapproksimasjonene i VHDL, for s  beregne estimeringsfeilen.
% 
% % Parameter    Beskrivelse               Initial verdi  Operating range
% % input_file   Navnet p hdr-bildefilen  ingen          ingen

function [ting error_output]= find_error(input_file)

% pner fila
fid_1 = fopen(input_file, 'r');
% Nullstiller variablene
i=1;
max_error = 0;
max_error_index = 0;
max_error_percent = 0;
max_error_percent_index = 0;
min_error = 0;
min_error_index = 0;
min_error_percent = 0;
min_error_percent_index = 0;
% Setter noen konstanter som skal brukes under utregningen
pow_2_1 = [1 2 4 8 16 32 64 128 256 512 1024 2048 4096 8192 16384 32768 65536 131072];
pow_2_2 = [16 8 4 2 1 0.5 0.25 0.125 0.0625 0.03125 0.015625 0.0078125 0.00390625 0.001953125 0.0009765625 0.00048828125 0.000244140625 0.0001220703125];
% Tar tiden p utregningen
tic
% Starter utregningen, fortsetter s lenge enden p filen IKKE er ndd
while (feof(fid_1) == 0)
% Nullstiller variable    
    input = 0;
    output= 0;
    final_output = 0;        
% Leser neste linje i fila    
    tline = fgetl(fid_1);
    streng_lengde = size(tline,2);
    if(streng_lengde==37 && i<262144)
% Regner ut frste kolonne, inngangsverdien til logaritme-enheten        
        for(j=1:1:18)
            input = input + (str2num(tline(j)))*(pow_2_1(19-j));
        end
% Henter ut andre kolonne, utgangsverdien til logaritmeenheten
        for(d=20:1:37)
            output(d-19) = str2num(tline(d));            
        end
% Regner ut andre kolonne, utgangsverdien til logaritme-enheten
        for(j=1:1:18)
            final_output = final_output + (output(j))*(pow_2_2(j));
        end
% Sjekker om inngangsverdien var ulik null, isfall s regnes
% estimeringsfeilen ut.
        if(input~=0 && input~=1)
            result = log2(input);            
            error = result - final_output;
            error_percent = 100*error/result;
        else
            error = 0;
            error_percent = 0;
        end
% Sjekker etter maksimal positiv feilprosent        
        if(error_percent > max_error_percent)
            max_error_percent = error_percent;
            max_error_percent_index = i;
        end
% Sjekker etter maksimal negativ feilprosent        
        if(error_percent < min_error_percent)
            min_error_percent = error_percent;
            min_error_percent_index = i;
        end
% Sjekker etter maksimal positiv feil        
        if(error > max_error)
            max_error = error;
            max_error_index = i;
        end
% Sjekker etter maksimal negativ feil        
        if(error < min_error)
            min_error = error;
            min_error_index = i;
        end        
    else
        return;
    end

% Lagrer inngangssverdien, ideell utgangsverdi, estimert utgangsverdi, 
% feilverdi og feilprosent for hver av inngangssignalene.
    ting(i,1)=input;
    ting(i,2)=result;
    ting(i,3)=final_output;
    ting(i,4)=error;
    ting(i,5)=error_percent;
    i=i+1;
end
% Ser hvor lang tid beregningene har tatt
toc

% Lagrer maksimal positiv feil, maksimal negativ feil, maksimal positiv
% filprosent, maksimal negativ feilprosent og indeksene til alle disse
% verdiene.
error_output = [min_error max_error min_error_index max_error_index min_error_percent max_error_percent min_error_percent_index max_error_percent_index];
