% % Denne funksjonen Leser ut det ferdige komprimerte resultatet som er
% % lagret fra VHDL-toppniv-testbenken som baserer seg p den serielle 
% % tidsmultipleksede arkitekturen.
% 
% % Parameter           Description                         Initial value       Operating range
% % vhdl_output_file    utgangsfilen fra testbenken         --                  --
% % height_in           nsket hyde p bildet              0                   [1     ; >
% % width_in            nsket bredde p bildet             0                   [1     ; >
% % dim_in              nsket dimansjon p bildet          0                   [1     ;  3]
% % store_picture_file  Navn p bitmapfil som genereres     --                  --

function output = read_vhdl_output_small(vhdl_output_file, height_in, width_in, dim_in, store_picture_file)

% Starter tidtakningen p operasjonen
tic

% Laster inn tekstfilen som inneholder pixelverdiene
I = load(vhdl_output_file);

% Sjekker dimensjonen p det komprimerte bildet.
[height_width_dim] = size(I);

% Sjekker at dimansjonene p det komprimerte bildet stemmer overens med det
% bildet man nsker  lage.
if(height_width_dim ~= (height_in*width_in*dim_in))
    output = 'error in dimensions'
    return;
end

% Lager et nytt bildearray som tar hensyn til antall dimansjoner, slik at
% hver farge fr sin egen dimensjon.
for(i=1:1:height_in)
    for(j=1:1:width_in)
        for(d=1:1:3)
            k = ((i-1)*width_in) + j;
            output(i, j, d) = I(d + (k-1)*3);
        end
    end
end

% Leser ut hvor lang tid funksjonen brukte p  lage bildet
toc

% Viser frem bildet p skjermen
image(output/256);

% Lagrer bildet som bitmapfil
imwrite(output/256, store_picture_file, 'bmp');

