---------------------------------------------------------------
-- Generic N-bit adder
-- Source is taken from [Maryland] 
-- (http://www.csee.umbc.edu/help/VHDL/samples/add_g.vhdl)
-- with just minor corrections to fit this project.
-- This module is fully generic
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity add_g is
  generic(left : natural := 17         -- top bit
          );
    port (a    : in  std_logic_vector (left downto 0);
          b    : in  std_logic_vector (left downto 0);
          cin  : in  std_logic;
          sum  : out std_logic_vector (left downto 0);
          cout : out std_logic);
end entity add_g;

---------------------------------------------------------------
-- Behavioral model of the adder
---------------------------------------------------------------

architecture behavior of add_g is
begin  -- behavior
  adder: process (a, b, cin)--, carry, isum)
     variable carry : std_logic; -- internal
     variable isum : std_logic_vector(left downto 0);  -- internal  
         begin             
           carry := cin;
           for i in 0 to left loop
             isum(i) := a(i) xor b(i) xor carry;
             carry  := (a(i) and b(i)) or (a(i) and carry) or (b(i) and carry);
           end loop;           
           sum  <= isum;
           cout <= carry;
         end process adder;
end architecture behavior;  -- of add_g