---------------------------------------------------------------
-- 18-bit Shifter for the antilog-circuit
-- This module is not generic
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity Antilog_Shifter18 is          	
port(
    number_of_shifts : in std_logic_vector(4 downto 0);
    input            : in std_logic_vector(17 downto 0);
    output           : out std_logic_vector(17 downto 0));
end Antilog_Shifter18;

---------------------------------------------------------------
-- Behavioral architecture for the shifter
---------------------------------------------------------------

architecture behavioral of Antilog_Shifter18 is
begin   

-- Shifting the input-signal the assigned amount of shifts

process(number_of_shifts, input)
begin
       output(17 downto 0) <= "000000000000000000";
	case number_of_shifts(4 downto 0) is
		when "00000" => output(0) <= input(17);
		when "00001" => output(1 downto 0) <= input(17 downto 16);
		when "00010" => output(2 downto 0) <= input(17 downto 15);
		when "00011" => output(3 downto 0) <= input(17 downto 14);
		when "00100" => output(4 downto 0) <= input(17 downto 13);
		when "00101" => output(5 downto 0) <= input(17 downto 12);
		when "00110" => output(6 downto 0) <= input(17 downto 11);
		when "00111" => output(7 downto 0) <= input(17 downto 10);
		when "01000" => output(8 downto 0) <= input(17 downto 9);
		when "01001" => output(9 downto 0) <= input(17 downto 8);
		when "01010" => output(10 downto 0) <= input(17 downto 7);
		when "01011" => output(11 downto 0) <= input(17 downto 6);
		when "01100" => output(12 downto 0) <= input(17 downto 5);
		when "01101" => output(13 downto 0) <= input(17 downto 4);
		when "01110" => output(14 downto 0) <= input(17 downto 3);
		when "01111" => output(15 downto 0) <= input(17 downto 2);
		when "10000" => output(16 downto 0) <= input(17 downto 1);
		when "10001" => output(17 downto 0) <= input(17 downto 0);				   
		when others			            =>	null;
	end case;	
end process;

end architecture behavioral; -- of Antilog_Shifter18
