---------------------------------------------------------------
-- 18-bits logarithmic shifter. Submodule for the SanGregory99 Logarithm module.
-- with minor adjustments to fit this project
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity Shifter18 is          	-- 
port(
    number_of_shifts : in std_logic_vector(4 downto 0);
    input            : in std_logic_vector(17 downto 0);
    output           : out std_logic_vector(17 downto 0));
end Shifter18;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture behavioral of Shifter18 is
begin   

-- Shifting the input the number of shifts specified by the number_of_shifts-input
process(number_of_shifts, input)
begin
       output(17 downto 0) <= "000000000000000000";
	case number_of_shifts(4 downto 0) is
		when "00000" => null; --output(17) <= input(0);
		when "00001" => output(17) <= input(0);
		when "00010" => output(17 downto 16) <= input(1 downto 0);
		when "00011" => output(17 downto 15) <= input(2 downto 0);
		when "00100" => output(17 downto 14) <= input(3 downto 0);
		when "00101" => output(17 downto 13) <= input(4 downto 0);
		when "00110" => output(17 downto 12) <= input(5 downto 0);
		when "00111" => output(17 downto 11) <= input(6 downto 0);
		when "01000" => output(17 downto 10) <= input(7 downto 0);
		when "01001" => output(17 downto 9) <= input(8 downto 0);
		when "01010" => output(17 downto 8) <= input(9 downto 0);
		when "01011" => output(17 downto 7) <= input(10 downto 0);
		when "01100" => output(17 downto 6) <= input(11 downto 0);
		when "01101" => output(17 downto 5) <= input(12 downto 0);
		when "01110" => output(17 downto 4) <= input(13 downto 0);
		when "01111" => output(17 downto 3) <= input(14 downto 0);
		when "10000" => output(17 downto 2) <= input(15 downto 0);
		when "10001" => output(17 downto 1) <= input(16 downto 0);				   
		when others			            =>	null;
	end case;	
end process;

end architecture behavioral; -- of Shifter18
