---------------------------------------------------------------
-- 18-bit linear approximation antiloarithm after an idea from abed00
-- This module is not generic
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

---------------------------------------------------------------
--Defining the entity
---------------------------------------------------------------

entity antilogarithm is
    port(
       input   :   in std_logic_vector(17 downto 0);
       output  :   out std_logic_vector(17 downto 0));
end entity antilogarithm;

---------------------------------------------------------------
-- Behavioral architecture 
---------------------------------------------------------------

architecture behavioral of antilogarithm is

-- Defining the shifter-component

  component Antilog_Shifter18
      port(
      number_of_shifts   : in std_logic_vector(4 downto 0);
      input              : in std_logic_vector(17 downto 0);
      output             : out std_logic_vector(17 downto 0));
  end component Antilog_Shifter18;
  

	signal internal    : std_logic_vector(17 downto 0);    
	signal LOD5        : std_logic_vector(4 downto 0); 
	
begin

-- Initializing the shifter-component

Anti_shifter: Antilog_Shifter18   port map(LOD5, internal, output);

-- assigning the internal signals in an combinatoral process

no_clocking:process(input, internal)
begin
           LOD5(4 downto 0)        <= input(17 downto 13);     
           internal(17)            <= '1';
           internal(16 downto 4)   <= input(12 downto 0);           
           internal(3 downto 0)    <= "0000";
    
end process no_clocking;

end architecture;