---------------------------------------------------------------
-- Testbench for testing the 18-bit antilogarithmic circuit antilogarithm_18
-- This testbench also logs the results in a txt-file called antilogarithm_18_tb_log.txt
-- Matlab is recomended to evaluate the txt-file.
---------------------------------------------------------------
library STD;
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_textio.all;
use STD.textio.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------
entity antilogarithm_tb is
end antilogarithm_tb;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------
architecture circuits of antilogarithm_tb is
    
      file   write_file : text  open write_mode is "antilogarithm_18_tb_log.txt";    
    
      signal one        : std_logic_vector(17 downto 0) := "000000000000000001";
	  	signal evaluate   : std_logic;
 	 	signal clk        : std_logic := '0'; 
  		signal output     : std_logic_vector(17 downto 0);
  		signal input						: std_logic_vector(17 downto 0) := "000000000000000001";

-- Defining the DUT
  component antilogarithm 
    port(
       input   :   in std_logic_vector(17 downto 0);
       clk     :   in std_logic;
       output  :   out std_logic_vector(17 downto 0));
  end component antilogarithm;

begin  
    
-- Initializing the DUT    
  antilogarithm_testsubject:  antilogarithm port map(input, clk, output); 

-- Defining the clock
clocking:process
begin
    loop
       wait for 5 ns;
       clk <= not clk;
    end loop;
end process;

-- Logging the results in the file antilogarithm_18_tb_log.txt
logging:process(clk)
   variable my_line : STD.textio.line;
   variable lcntr : std_logic_vector(4 downto 0);
   alias swrite is write [line, string, side, width] ;
begin
   if(not(output="UUUUUUUUUUUUUUUUUU")) then
      write(my_line, input);
      swrite(my_line, " ");
      write(my_line, output);
      writeline(write_file, my_line);           
   end if;
end process logging;    

-- The test 
test:process 
 	begin
-- Resetting 	    
		evaluate <= '1';
		input <= "000000000000000000";
		wait for 1 ns;
-- Test-loop		
   for i in 0 to 262143 loop 
		input <= unsigned(input) + unsigned(one);
		wait for 5 ns;
	end loop;
	assert false report "NONE. End of simulation." severity failure;
end process test;
end architecture circuits; 