---------------------------------------------------------------
-- Testbench for the maximum module
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

---------------------------------------------------------------
-- Entity
---------------------------------------------------------------

entity maksimum_tb is
end entity maksimum_tb;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture behavior of maksimum_tb is

-- Generic constant       
    constant NBITS : natural := 18;

-- Defining the DUT       
component maksimum
   generic(NBITS : natural :=18 );
   port 
      (input   : in std_logic_vector(NBITS-1 downto 0);
       clk     : in std_logic;
       reset   : in std_logic;
       output  : out std_logic_vector(NBITS-1 downto 0)
   );
end component;
    
    signal input : std_logic_vector(NBITS-1 downto 0) := (others=>'0');
    signal output: std_logic_vector(NBITS-1 downto 0);    
    signal clk   : std_logic := '0';    
    signal reset : std_logic := '0';        
begin  

-- Initializing the DUT  
max_DUT: component maksimum port map(input, clk, reset, output);

-- Clock generation    
clock: process 
begin
   clk <= not clk;
   wait for 5 ns;
end process clock;

-- The test  
test: process
begin
    reset <= '0';
    wait for 10 ns;
-- Test loop. Set the loop-borders to fit your test      
   for i in 0 to 1000 loop
       input <= conv_std_logic_vector(i, 18);
-- Checks the internal register-reset         
       if(i=100) then 
          reset <= '1';
       else
          reset <= '0';
       end if;
       wait for 15 ns;
   end loop;
end process test;

end architecture behavior;  -- of maksimum_tb