---------------------------------------------------------------
-- Leading one detector, documentated in Abed00
-- with minor adjustments to fit this project
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity leading_one_abed00 is          	-- 
port(
    input   : in std_logic_vector(17 downto 0);
    zero_in : out std_logic;
    output  : out std_logic_vector(17 downto 0));
end leading_one_abed00;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture circuits of leading_one_abed00 is

-- Defining the components

 component leading_one_sub_abed00   
    port(    
    input   : in std_logic_vector(4 downto 0);
    output  : out std_logic_vector(4 downto 0)
    );
  end component leading_one_sub_abed00;

	signal internal_input  : std_logic_vector(4 downto 0);
	signal output_control  : std_logic_vector(4 downto 0);	
	signal input_control   : std_logic_vector(4 downto 0);
	signal internal_output : std_logic_vector(19 downto 0);

begin  -- circuits of leading_one_18
    
    internal_input(4 downto 3) <= "00";
    internal_input(2 downto 0) <= input(17 downto 15);

-- Initializing the components
st0: leading_one_sub_abed00 port map(internal_input, internal_output(19 downto 15));  
st1: leading_one_sub_abed00 port map(input(14 downto 10), internal_output(14 downto 10));
st2: leading_one_sub_abed00 port map(input(9 downto 5), internal_output(9 downto 5));
st3: leading_one_sub_abed00 port map(input(4 downto 0), internal_output(4 downto 0));
st4: leading_one_sub_abed00 port map(input_control,output_control);

-- connectiong the internal signals according to the documantation in Abed00
   input_control(4) <= '0';
   input_control(0) <= input(4) or input(3) or input(2) or input(1) or input(0);
   input_control(1) <= input(9) or input(8) or input(7) or input(6) or input(5);
   input_control(2) <= input(14) or input(13) or input(12) or input(11) or input(10);
   input_control(3) <= input(17) or input(16) or input(15);

   zero_in <= input_control(3) or input_control(2) or input_control(1) or input_control(0);

   output(17) <= internal_output(17) AND output_control(3);
   output(16) <= internal_output(16) AND output_control(3);
   output(15) <= internal_output(15) AND output_control(3);
   output(14) <= internal_output(14) AND output_control(2);
   output(13) <= internal_output(13) AND output_control(2);
   output(12) <= internal_output(12) AND output_control(2);
   output(11) <= internal_output(11) AND output_control(2);
   output(10) <= internal_output(10) AND output_control(2);
   output(9) <= internal_output(9) AND output_control(1);
   output(8) <= internal_output(8) AND output_control(1);
   output(7) <= internal_output(7) AND output_control(1);
   output(6) <= internal_output(6) AND output_control(1);
   output(5) <= internal_output(5) AND output_control(1);
   output(4) <= internal_output(4) AND output_control(0);
   output(3) <= internal_output(3) AND output_control(0);
   output(2) <= internal_output(2) AND output_control(0);
   output(1) <= internal_output(1) AND output_control(0);
   output(0) <= internal_output(0) AND output_control(0);
   

end architecture circuits; -- of leading_one_abed00