---------------------------------------------------------------
-- Leading one subcircuit for the Abed00 Logarithm module
-- with minor adjustments to fit this project
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity leading_one_sub_abed00 is          	-- 
     port(
         input   : in std_logic_vector(4 downto 0);
         output  : out std_logic_vector(4 downto 0)
         );
end leading_one_sub_abed00;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------
     
architecture circuits of leading_one_sub_abed00 is
       signal node1 : std_logic := '0';
       signal node2 : std_logic := '0';
       signal node3 : std_logic := '0';
       signal node4 : std_logic := '0';                     
       
begin  -- circuits of leading_one_sub_abed00

-- connectiong the internal signals with simple boolean equations according to the 
-- documentation in Abed00     
   node4   <= not(input(4));
   node3   <= ((NOT input(3)) AND node4);
   node2   <= ((NOT input(2)) AND node3);   
   node1   <= ((NOT input(1)) AND node2);        
     
   output(4) <= input(4);
   output(3) <= input(3) AND node4;
   output(2) <= input(2) AND node3;
   output(1) <= input(1) AND node2;
   output(0) <= input(0) AND node1;   
   
end architecture circuits; -- of leading_one_sub_abed00