---------------------------------------------------------------
-- Leading one detector subcircuit for the Abed00 and Abed03 Logarithm unit
-- For documentation, see Abed00
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity leading_one_sub_abed00 is          	-- 
     port(
         input   : in std_logic_vector(4 downto 0);
         output  : out std_logic_vector(4 downto 0)
         );
end leading_one_sub_abed00;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------
     
architecture circuits of leading_one_sub_abed00 is
       signal node1 : std_logic := '0';
       signal node2 : std_logic := '0';
       signal node3 : std_logic := '0';
       signal node4 : std_logic := '0';                     
       
begin 

-- Connecting the internal signals with simpel boolean equations according to Abed00     
   node4   <= not(input(4));
   node3   <= ((NOT input(3)) AND node4);-- OR input(3);
   node2   <= ((NOT input(2)) AND node3);-- OR input(2);   
   node1   <= ((NOT input(1)) AND node2);-- OR input(1);        
     
   output(4) <= input(4);
   output(3) <= input(3) AND node4;
   output(2) <= input(2) AND node3;
   output(1) <= input(1) AND node2;
   output(0) <= input(0) AND node1;   
   
end architecture circuits;