---------------------------------------------------------------
-- FullAdder-component in the SanGregory99 Leading one detector submodule
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity full_adder is
port(
   C   : in std_logic;
   A   : in std_logic;
   B   : in std_logic;
   S   : out std_logic;
   C_out: out std_logic);
end full_adder;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture behavioral of full_adder is
    signal D    : std_logic;
    signal E    : std_logic;
    signal F    : std_logic;
begin
-- Simple combinatoral full-adder process       
    process(C , A , B, D, E, F)
    begin
        D     <= A XOR B;
        E     <= C AND D;
        F     <= A AND B;
        S     <= C XOR D;
        C_out <= E OR F;
   end process;
end architecture behavioral;