---------------------------------------------------------------
-- Leading one detector for the SanGregory99 Logarithm unit
-- with minor adjustments to fit this project
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity leading_one_18 is          	-- 
port(
    input   : in std_logic_vector(17 downto 0);
    eval 			: in std_logic;
    Shift   : out std_logic_vector(17 downto 0));
end leading_one_18;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture circuits of leading_one_18 is

-- Defining the subcomponent
 component leading_one_sub   
    port(    
    Gen     : in std_logic;
    Dn      : in std_logic;
    Dn_1    : in std_logic;
    Eval_inv: in std_logic;
    Gen_out : out std_logic;
    Shiftn  : out std_logic;               
    Shiftn_1: out std_logic);
  end component leading_one_sub;

	signal gen : std_logic_vector(8 downto 0);
	signal eval_inv : std_logic;
begin  -- circuits of leading_one_18

   eval_inv <= not eval;

-- Initializing the subcomponents
st0: leading_one_sub port map('1'	, input(17), input(16) , eval_inv, gen(0), shift(17), shift(16));  
st1: leading_one_sub port map(gen(0)	, input(15), input(14) , eval_inv, gen(1), shift(15), shift(14));
st2: leading_one_sub port map(gen(1), input(13), input(12) , eval_inv, gen(2), shift(13), shift(12));
st3: leading_one_sub port map(gen(2), input(11), input(10) , eval_inv, gen(3), shift(11), shift(10));
st4: leading_one_sub port map(gen(3), input(9), input(8) , eval_inv, gen(4), shift(9), shift(8));
st5: leading_one_sub port map(gen(4), input(7), input(6) , eval_inv, gen(5), shift(7), shift(6));
st6: leading_one_sub port map(gen(5), input(5), input(4) , eval_inv, gen(6), shift(5), shift(4));
st7: leading_one_sub port map(gen(6), input(3), input(2) , eval_inv, gen(7), shift(3), shift(2));
st8: leading_one_sub port map(gen(7), input(1), input(0) , eval_inv, gen(8), shift(1), shift(0));

end architecture circuits; -- of leading_one_18