---------------------------------------------------------------
-- Leading one detector subcircuit for the SanGregory Logarithm unit
-- For documentation, see SanGregory99
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity leading_one_sub is          	
port(
    Gen     : in std_logic;
    Dn      : in std_logic;
    Dn_1    : in std_logic;
    Eval_inv: in std_logic;
    Gen_out : out std_logic;
    Shiftn  : out std_logic;               
    Shiftn_1: out std_logic);
end leading_one_sub;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture circuits of leading_one_sub is
  signal node1 : std_logic := '0';
  signal Gen_1 : std_logic := '0';  

begin 

-- Cell - A
node1   <= Dn nand Gen;
Shiftn  <= Eval_inv nor node1;
Gen_1   <= node1 nand Gen;

-- cell - B
Gen_out  <= Gen_1 nor Dn_1;
Shiftn_1 <= Eval_inv nor (Dn_1 nand (not Gen_1));

end architecture circuits; 
